<template>
  <div @click="dialog = !dialog">
    <!-- ダイアローグが表示されている場合 -->
    <v-dialog v-model="dialog">
      <v-card>
        <v-card-title class="headline">
          <span>入力 ({{ caption }})</span>
        </v-card-title>
        <v-card-text>
          <!-- カブ価 -->
          <v-text-field
            label="カブ価"
            v-model="inputPrice"
            type="number"
            autofocus
            @keydown.enter="save"
          />
          <!-- 保有カブ数 (SUNのみ) -->
          <v-text-field
            label="保有カブ数"
            v-if="weekIsSun"
            v-model="inputAmount"
            type="number"
            @keydown.enter="save"
          />
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancel">CANCEL</v-btn>
          <v-btn color="green" @click="save">SAVE</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- ダイアローグが表示されていない場合 -->
    <div v-show="!dialog">
      <span>{{ price }}</span>
      <span v-if="weekIsSun && amount">({{ amount.toLocaleString() }})</span>
      <v-icon class="ml-2 grey--text">mdi-pencil</v-icon>
    </div>
  </div>
</template>

<script>
export default {
  props: [
    // 入力内容の説明文
    'caption',
    // 曜日 (例: 'mon')
    'week',
    // 午前午後 (例: 'am')
    'ampm'
  ],
  data () {
    return {
      // ダイアローグが表示されているかどうか
      dialog: false,
      // 入力されたカブ価
      // 初期値はStoreのカブ価
      inputPrice: this.price,
      // 入力された保有カブ数 (SUNのみ)
      // 初期値はStoreの保有株数
      inputAmount: this.amount,
    }
  },
  methods: {
    /**
     * ダイアローグを閉じる
     */
    closeDialog () {
      this.dialog = false
    },

    /**
     * SAVEボタン処理
     */
    save () {
      // カブ価を設定する
      const priceArg = { price: Number(this.inputPrice), week: this.week, ampm: this.ampm }
      this.$store.dispatch('stock/setPrice', priceArg)

      // 保有カブ数を設定する (SUNのみ)
      if (this.weekIsSun) {
        const amountArg = { amount: Number(this.inputAmount) }
        this.$store.dispatch('stock/setAmount', amountArg)
      }

      // ダイアローグを閉じる
      this.closeDialog()
    },

    /**
     * CANCELボタン処理
     */
    cancel () {
      // ダイアローグを閉じる
      this.closeDialog()
    }
  },
  computed: {
    // Storeのカブ価
    price () {
      const priceKey = this.week + (this.ampm || '')
      return this.$store.getters['stock/prices'][priceKey]
    },
    // Storeの保有カブ数
    amount () {
      return this.$store.getters['stock/amount']
    },
    // 曜日がsunの場合はtrueを返す
    weekIsSun () {
      return this.week == 'sun'
    }
  }
}
</script>

<style scoped>
</style>
